VERSION 5.00
Begin VB.Form FDemo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Demo"
   ClientHeight    =   8040
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   10410
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   8040
   ScaleWidth      =   10410
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClearAndRefill 
      Caption         =   "   "
      Height          =   450
      Left            =   7305
      TabIndex        =   12
      Top             =   4005
      Width           =   2925
   End
   Begin VB.CheckBox chkUniqueness 
      Caption         =   " "
      Height          =   315
      Left            =   3915
      TabIndex        =   11
      Top             =   4050
      Width           =   3165
   End
   Begin VB.CommandButton cmdAddItem 
      Caption         =   " "
      Height          =   675
      Left            =   300
      TabIndex        =   9
      Top             =   7035
      Width           =   1500
   End
   Begin VB.CommandButton cmdDelSelected 
      Caption         =   " "
      Enabled         =   0   'False
      Height          =   675
      Left            =   2175
      TabIndex        =   10
      Top             =   7050
      Width           =   1500
   End
   Begin VB.Frame frmOrderRelation 
      Caption         =   "Ordering Relation"
      Height          =   1635
      Left            =   3840
      TabIndex        =   5
      Top             =   1890
      Width           =   6390
      Begin VB.OptionButton optOrderingRelation 
         Caption         =   " "
         Enabled         =   0   'False
         Height          =   360
         Index           =   2
         Left            =   195
         TabIndex        =   8
         Top             =   1035
         Width           =   5955
      End
      Begin VB.OptionButton optOrderingRelation 
         Caption         =   " ,   CCaseSensitiveCompRelation"
         Enabled         =   0   'False
         Height          =   360
         Index           =   1
         Left            =   195
         TabIndex        =   7
         Top             =   675
         Width           =   5955
      End
      Begin VB.OptionButton optOrderingRelation 
         Caption         =   " ,    "
         Enabled         =   0   'False
         Height          =   360
         Index           =   0
         Left            =   195
         TabIndex        =   6
         Top             =   315
         Value           =   -1  'True
         Width           =   4410
      End
   End
   Begin VB.Frame frmOrderingMode 
      Caption         =   "Ordering Mode ()"
      Height          =   1515
      Left            =   3840
      TabIndex        =   1
      Top             =   195
      Width           =   6390
      Begin VB.OptionButton optOrderingMode 
         Caption         =   "  (omDescending)"
         Height          =   315
         Index           =   2
         Left            =   195
         TabIndex        =   4
         Top             =   1050
         Width           =   4050
      End
      Begin VB.OptionButton optOrderingMode 
         Caption         =   "  (omAscending)"
         Height          =   315
         Index           =   1
         Left            =   195
         TabIndex        =   3
         Top             =   690
         Width           =   4050
      End
      Begin VB.OptionButton optOrderingMode 
         Caption         =   "  (omDisabled)"
         Height          =   315
         Index           =   0
         Left            =   195
         TabIndex        =   2
         Top             =   330
         Value           =   -1  'True
         Width           =   2265
      End
   End
   Begin StrangeListBoxDemo.StrangeListBox ListCtl 
      Height          =   6705
      Left            =   300
      TabIndex        =   0
      Top             =   210
      Width           =   3375
      _ExtentX        =   5953
      _ExtentY        =   6535
   End
End
Attribute VB_Name = "FDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim CaseInsensitiveOrderRelation        As New CCaseInsensitiveCompRelation
Dim NatSortOrderRelation                As New CNatSortRelation


Private Sub chkUniqueness_Click()
    ListCtl.ForceUniqueness = chkUniqueness.Value <> vbUnchecked
End Sub

Private Sub cmdAddItem_Click()
    Dim sNewItem As String
    
    sNewItem = InputBox("   :", "", " ")
    
    ListCtl.ListIndex = ListCtl.AddItem(sNewItem)
End Sub

Private Sub cmdClearAndRefill_Click()
    ListCtl.Clear
    FillList
End Sub

Private Sub cmdDelSelected_Click()
    ListCtl.RemoveItem ListCtl.ListIndex
    cmdDelSelected.Enabled = False
End Sub

Private Sub Form_Load()
    If MsgBox(" ?", vbYesNo Or vbDefaultButton2 Or vbQuestion) = vbYes Then
        chkUniqueness.Value = vbChecked
    End If
    
    FillList
End Sub

Private Sub ListCtl_ItemSelected()
    cmdDelSelected.Enabled = True
End Sub

Private Sub optOrderingMode_Click(Index As Integer)
    Select Case Index
        Case 0: ListCtl.OrderingMode = omDisabled
        Case 1: ListCtl.OrderingMode = omAscending
        Case 2: ListCtl.OrderingMode = omDescending
    End Select
    
    optOrderingRelation(0).Enabled = (Index <> 0)
    optOrderingRelation(1).Enabled = (Index <> 0)
    optOrderingRelation(2).Enabled = (Index <> 0)
End Sub

Private Sub optOrderingRelation_Click(Index As Integer)
    Select Case Index
        Case 0: Set ListCtl.OrderingRelation = Nothing
        Case 1: Set ListCtl.OrderingRelation = CaseInsensitiveOrderRelation
        Case 2: Set ListCtl.OrderingRelation = NatSortOrderRelation
    End Select
End Sub

Private Sub FillList()
    With ListCtl
        .AddItem ""
        .AddItem ""
        .AddItem ""
        .AddItem ""
        .AddItem " "
        .AddItem ""
        .AddItem " 2"
        .AddItem " 3"
        .AddItem " 1"
        .AddItem "Bazu"
        .AddItem "  1"
        .AddItem "bAba"
        .AddItem "  3"
        .AddItem "01"
        .AddItem "  7"
        .AddItem "10"
        .AddItem "  12"
        .AddItem "02"
        .AddItem "  35"
        .AddItem " "
        .AddItem "  24"
        .AddItem ""
        .AddItem "3"
        .AddItem "  "
        .AddItem "  101"
        .AddItem "  "
        .AddItem "       "
        .AddItem "  "
        .AddItem "  "
        .AddItem "  "
        .AddItem "10"
        .AddItem "02"
        .AddItem "01"
    End With
End Sub
